/// <reference types="react" />
import React from 'react';
import { EditorState, EditorStateConfig, Extension } from '@codemirror/state';
import { EditorView, ViewUpdate } from '@codemirror/view';
type CodeMirrorProps = {
    value?: string;
    selection?: EditorStateConfig['selection'];
    onUpdate?: (update: ViewUpdate) => void;
    onEditorViewChange?: (editorView: EditorView) => void;
    onEditorStateChange?: (editorState: EditorState) => void;
    extensions?: Extension[];
    elementProps?: React.ComponentProps<'div'>;
};
declare const CodeMirror: React.ForwardRefExoticComponent<CodeMirrorProps & React.RefAttributes<HTMLDivElement>>;
export { CodeMirror as default, CodeMirrorProps };
